# Bilder mit Hilfe des Delphi-Programms bmp2bytes565.exe in Binär-Format umwandeln:
# Die ersten beiden Bytes geben dabei die Breite und Höhe des Bildes an, die restlichen Bytes
# stellen für jedes Pixel jeweils das rg- und das gb-Byte dar.
# Die Pixel-Daten werden mit blit_buffer direkt in das Display-RAM geschrieben; sehr einfach und enorm schnell!!!

from machine import Pin, SPI
import st7789

spi = SPI(2, baudrate=20000000, polarity=1, sck=Pin(18), mosi=Pin(19))
display = st7789.ST7789(spi, 135, 240,  reset=Pin(23, Pin.OUT), cs=Pin(5, Pin.OUT), dc=Pin(16, Pin.OUT), backlight=Pin(4, Pin.OUT), rotation=3)
# Landscape

display.init()
display.fill(st7789.YELLOW) # Hintergrund

# Breite und Höhe des Bildes...
f = open('testbild.bin', 'rb') # öffnen mit "[r]eading as [b]inary"

data = f.read(2) # Breite und Höhe
data = list(data) # bytearray -> Liste von Zahlen
x_max = data[0]
y_max = data[1]

# Pixel-Daten holen und in Display-Speicher übertragen...
data = f.read(x_max*y_max*2) # alle Pixel-Bytes
display.blit_buffer(data, 50, 10, x_max, y_max)

data = 0 # vermeidet "MemoryError: memory allocation failed, allocating ..." beim Beenden des Programms
    
f.close()    
  
    
    